#jinja2: lstrip_blocks: "True"

{% macro render_vhost_directives() %}
	gzip on;
	gzip_types text/plain application/json application/javascript text/css image/x-icon font/ttf image/gif;

	{% if docker_nginx_proxy_hsts_preload_enabled %}
		add_header Strict-Transport-Security "max-age=31536000; includeSubDomains; preload" always;
	{% else %}
		add_header Strict-Transport-Security "max-age=31536000; includeSubDomains" always;
	{% endif %}
	# duplicate X-Content-Type-Options & X-Frame-Options header
	# Enabled by container by default
	# add_header X-Content-Type-Options nosniff;
	# add_header X-Frame-Options SAMEORIGIN;
	add_header Referrer-Policy "strict-origin-when-cross-origin";

	{% if docker_nginx_proxy_floc_optout_enabled %}
		add_header Permissions-Policy interest-cohort=() always;
	{% endif %}

	proxy_cookie_path / "/; HTTPOnly; Secure";

	{% for configuration_block in docker_nginx_proxy_proxy_container_additional_server_configuration_blocks %}
		{{- configuration_block }}
	{% endfor %}

	location / {
		{% if docker_nginx_proxy_enabled %}
			{# Use the embedded DNS resolver in Docker containers to discover the service #}
			resolver 127.0.0.11 valid=5s;
			set $backend "docker-container:80";
			proxy_pass http://$backend;
		{% else %}
			{# Generic configuration for use outside of our container setup #}
			proxy_pass http://127.0.0.1:80;
		{% endif %}

		proxy_set_header Host $host;
		proxy_set_header X-Forwarded-For {{ docker_nginx_proxy_x_forwarded_for }};
	}
{% endmacro %}

server {
	listen {{ 8080 if docker_nginx_proxy_enabled else 80 }};
	listen [::]:{{ 8080 if docker_nginx_proxy_enabled else 80 }};


	server_name {{ docker_nginx_proxy_proxy_container_hostname }};

	server_tokens off;
	root /dev/null;

	{% if docker_nginx_proxy_https_enabled %}
		location /.well-known/acme-challenge {
			{% if docker_nginx_proxy_enabled %}
				{# Use the embedded DNS resolver in Docker containers to discover the service #}
				resolver 127.0.0.11 valid=5s;
				set $backend "{{ docker-certbot }}:8080";
				proxy_pass http://$backend;
			{% else %}
				{# Generic configuration for use outside of our container setup #}
				proxy_pass http://127.0.0.1:{{ docker_ssl_lets_encrypt_certbot_standalone_http_port }};
			{% endif %}
		}

		location / {
			return 301 https://$http_host$request_uri;
		}
	{% else %}
		{{ render_vhost_directives() }}
	{% endif %}
}

{% if docker_nginx_proxy_https_enabled %}
server {
	listen {{ 8443 if docker_nginx_proxy_enabled else 443 }} ssl http2;
	listen [::]:{{ 8443 if docker_nginx_proxy_enabled else 443 }} ssl http2;

	server_name {{ docker_nginx_proxy_proxy_container_hostname }};

	server_tokens off;
	root /dev/null;

	ssl_certificate {{ docker_ssl_config_dir_path }}/live/{{ docker_nginx_proxy_proxy_container_hostname }}/fullchain.pem;
	ssl_certificate_key {{ docker_ssl_config_dir_path }}/live/{{ docker_nginx_proxy_proxy_container_hostname }}/privkey.pem;

	ssl_protocols {{ docker_nginx_proxy_ssl_protocols }};
	{% if docker_nginx_proxy_ssl_ciphers != "" %}
	ssl_ciphers {{ docker_nginx_proxy_ssl_ciphers }};
	{% endif %}
	ssl_prefer_server_ciphers {{ docker_nginx_proxy_ssl_prefer_server_ciphers }};

	{% if docker_nginx_proxy_ocsp_stapling_enabled %}
		ssl_stapling on;
		ssl_stapling_verify on;
		ssl_trusted_certificate {{ docker_ssl_config_dir_path }}/live/{{ docker_nginx_proxy_proxy_container_hostname }}/chain.pem;
	{% endif %}

	{% if docker_nginx_proxy_ssl_session_tickets_off %}
		ssl_session_tickets off;
	{% endif %}
	ssl_session_cache {{ docker_nginx_proxy_ssl_session_cache }};
	ssl_session_timeout {{ docker_nginx_proxy_ssl_session_timeout }};

	{{ render_vhost_directives() }}
}
{% endif %}